using Microsoft.EntityFrameworkCore;
using PlumbingRepairContracts.BindingModels;
using PlumbingRepairContracts.SearchModels;
using PlumbingRepairContracts.StoragesContracts;
using PlumbingRepairContracts.ViewModels;
using PlumbingRepairDatabaseImplement.Models;

namespace PlumbingRepairDatabaseImplement.Implements
{
    public class OrderStorage : IOrderStorage
    {
        public List<OrderViewModel> GetFullList()
        {
            using var context = new PlumbingRepairDataBase();

            return context.Orders
                .Include(x => x.Work)
                .Include(x => x.Client)
				.Include(x => x.Implementer)
				.Select(x => x.GetViewModel)
                .ToList();
        }

        public List<OrderViewModel> GetFilteredList(OrderSearchModel model)
        {
			using var context = new PlumbingRepairDataBase();
			if (model.Id.HasValue)
			{
				return context.Orders
					.Include(x => x.Work)
					.Include(x => x.Client)
					.Include(x => x.Implementer)
					.Where(x => x.Id == model.Id)
					.Select(x => x.GetViewModel)
					.ToList();
			}
			else if (model.DateFrom != null && model.DateTo != null)
			{
				return context.Orders
					.Include(x => x.Work)
					.Include(x => x.Client)
					.Include(x => x.Implementer)
					.Where(x => x.DateCreate >= model.DateFrom && x.DateCreate <= model.DateTo)
					.Select(x => x.GetViewModel)
					.ToList();
			}
			else if (model.ClientId.HasValue)
			{
				return context.Orders
					.Include(x => x.Work)
					.Include(x => x.Client)
					.Include(x => x.Implementer)
					.Where(x => x.ClientId == model.ClientId)
					.Select(x => x.GetViewModel)
					.ToList();
			}
			else if (model.ImplementerId.HasValue)
			{
				return context.Orders
					.Include(x => x.Work)
					.Include(x => x.Client)
					.Include(x => x.Implementer)
					.Where(x => x.ImplementerId == model.ImplementerId)
					.Select(x => x.GetViewModel)
					.ToList();
			}
			return context.Orders
				.Include(x => x.Work)
				.Include(x => x.Client)
				.Include(x => x.Implementer)
				.Where(x => model.Status == x.Status)
				.Select(x => x.GetViewModel)
				.ToList();
		}

        public OrderViewModel? GetElement(OrderSearchModel model)
        {
			if (!model.Id.HasValue)
			{
				return null;
			}

			using var context = new PlumbingRepairDataBase();

			return context.Orders
				.Include(x => x.Work)
				.Include(x => x.Client)
				.Include(x => x.Implementer)
				.FirstOrDefault(x => (!model.ImplementerId.HasValue || x.ImplementerId == model.ImplementerId) &&
									  (!model.Status.HasValue || x.Status == model.Status) &&
									  (!model.Id.HasValue || x.Id == model.Id))?.GetViewModel;
		}

        public OrderViewModel? Insert(OrderBindingModel model)
        {
            var newOrder = Order.Create(model);

            if (newOrder == null)
            {
                return null;
            }

            using var context = new PlumbingRepairDataBase();

            context.Orders.Add(newOrder);
            context.SaveChanges();

            return context.Orders
                .Include(x => x.Work)
                .Include(x => x.Client)
				.Include(x => x.Implementer)
				.FirstOrDefault(x => x.Id == newOrder.Id)
                ?.GetViewModel;
        }

        public OrderViewModel? Update(OrderBindingModel model)
        {
            using var context = new PlumbingRepairDataBase();

            var order = context.Orders.FirstOrDefault(x => x.Id == model.Id);

            if (order == null)
            {
                return null;
            }

            order.Update(model);
            context.SaveChanges();

            return context.Orders
                .Include(x => x.Work)
                .Include(x => x.Client)
				.Include(x => x.Implementer)
				.FirstOrDefault(x => x.Id == model.Id)
                ?.GetViewModel;
        }

        public OrderViewModel? Delete(OrderBindingModel model)
        {
            using var context = new PlumbingRepairDataBase();

            var element = context.Orders.FirstOrDefault(rec => rec.Id == model.Id);

            if (element != null)
            {
                var deletedElement = context.Orders
                .Include(x => x.Work)
                .Include(x => x.Client)
				.Include(x => x.Implementer)
				.FirstOrDefault(x => x.Id == model.Id)
                ?.GetViewModel;
                context.Orders.Remove(element);
                context.SaveChanges();

                return deletedElement;
            }

            return null;
        }
    }
}
